# Summary

- [Why Exercise.rs](why-exercise.md)
- [Variables](variables.md)
- [Basic Types](basic-types/intro.md)
  - [Numbers](basic-types/numbers.md)
  - [Char, Bool and Unit](basic-types/char-bool-unit.md)
  - [Statements and Expressions](basic-types/statements-expressions.md)
  - [Functions](basic-types/functions.md)
- [Ownership and Borrowing](ownership/intro.md)
  - [Ownership](ownership/ownership.md)
  - [Reference and Borrowing](ownership/borrowing.md)
- [Compound Types](compound-types/intro.md)
  - [string and slice](compound-types/string-slice.md)
  - [tuple](compound-types/tuple.md)
  - [struct](compound-types/struct.md)
  - [enum](compound-types/enum.md)
  - [array](compound-types/array.md)
- [Flow Control](flow-control.md)
- [Pattern Match](pattern-match/intro.md)
  - [match, if let](pattern-match/match-iflet.md)
  - [Option destructing](pattern-match/option.md)
  - [Patterns](pattern-match/patterns.md)
- [Method](method.md)
- [Generics and Traits](generics-traits/intro.md)
  - [Generics](generics-traits/generics.md)
  - [Traits](generics-traits/traits.md)
  - [Trait Object](generics-traits/trait-object.md)
  - [Advance Traits](generics-traits/advance-traits.md)
- [Collection Types](collections/intro.md)
  - [Vector](collections/vector.md)
  - [HashMap](collections/hashmap.md)
- [Type Conversion](type-conversion.md)
- [Result and panic](result-panic/intro.md)
  - [panic!](result-panic/panic.md)
  - [result and ?](result-panic/result.md)
- [Crate and module](crate-module/intro.md)
  - [Crate](crate-module/crate.md)
  - [Module](crate-module/module.md)
  - [use and pub](crate-module/use-pub.md)
- [Comments and Docs](comments-docs.md)
- [Formatted output](formatted-output.md)
- [Lifetime](lifetime/intro.md)
  - [basic](lifetime/basic.md)
  - [&'static and T: 'static](lifetime/static.md)
  - [advance](lifetime/advance.md)
- [Functional programing](functional-programing/intro.md)
  - [Closure](functional-programing/cloure.md)
  - [Iterator](functional-programing/iterator.md)
- [newtype and Sized](newtype-sized.md)
- [Smart pointers](smart-pointers/intro.md)
  - [Box](smart-pointers/box.md)
  - [Deref](smart-pointers/deref.md)
  - [Drop](smart-pointers/drop.md)
  - [Rc and Arc](smart-pointers/rc-arc.md)
  - [Cell and RefCell](smart-pointers/cell-refcell.md)
- [Weak and Circle reference](weak.md)
- [Self referential](self-referential.md)
- [Threads](threads/intro.md)
  - [Basic using](threads/basic-using.md)
  - [Message passing](threads/message-passing.md)
  - [Sync](threads/sync.md)
  - [Atomic](threads/atomic.md)
  - [Send and Sync](threads/send-sync.md)
- [Global variables](global-variables.md)
- [Errors](errors.md)
- [unsafe](unsafe.md)
- [macro](macro.md)
- [Tests](tests/intro.md)
  - [Write Tests](tests/write-tests.md)
  - [Benchmark](tests/benchmark.md)
  - [Unit and Integration](tests/unit-integration.md)
  - [Assertions](tests/assertions.md)
- [Async/Await](async/intro.md)
  - [async and await!](async/async-await.md)
  - [Future](async/future.md)
  - [Pin and Unpin](async/pin-unpin.md)
  - [Stream](async/stream.md)
  